SparseDoubleMatrix2D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.impl.SparseDoubleMatrix2D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix.impl
Class SparseDoubleMatrix2D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix2D
                  cern.colt.matrix.DoubleMatrix2D
                      cern.colt.matrix.impl.SparseDoubleMatrix2D

All Implemented Interfaces:
  Cloneable, Serializable

public class SparseDoubleMatrix2D
extends DoubleMatrix2D

Sparse hashed 2-d matrix holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Note that this implementation is not synchronized. Uses a `OpenIntDoubleHashMap`, which is a compact and performant hashing technique.

Memory requirements:

Cells that

- are never set to non-zero values do not use any memory.
- switch from zero to non-zero state do use memory.
- switch back from non-zero to zero state also do use memory. However, their memory is automatically reclaimed from time to time. It can also manually be reclaimed by calling `trimToSize()`.

worst case: `memory [bytes] = (1/minLoadFactor) * nonZeros * 13`.
best case: `memory [bytes] = (1/maxLoadFactor) * nonZeros * 13`.
Where `nonZeros = cardinality()` is the number of non-zero cells. Thus, a 1000 x 1000 matrix with minLoadFactor=0.25 and maxLoadFactor=0.5 and 1000000 non-zero cells consumes between 25 MB and 50 MB. The same 1000 x 1000 matrix with 1000 non-zero cells consumes between 25 and 50 KB.

Time complexity:

This class offers expected time complexity `O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size` assuming the hash function disperses the elements properly among the buckets. Otherwise, pathological cases, although highly improbable, can occur, degrading performance to `O(N)` in the worst case. As such this sparse class is expected to have no worse time complexity than its dense counterpart `DenseDoubleMatrix2D`. However, constant factors are considerably larger.

Cells are internally addressed in row-major. Performance sensitive applications can exploit this fact. Setting values in a loop row-by-row is quicker than column-by-column, because fewer hash collisions occur. Thus

            for (int row=0; row < rows; row++) {
                    for (int column=0; column < columns; column++) {
                            matrix.setQuick(row,column,someValue);
                    }
            }

is quicker than

            for (int column=0; column < columns; column++) {
                    for (int row=0; row < rows; row++) {
                            matrix.setQuick(row,column,someValue);
                    }
            }

Version:
  1.0, 09/24/99
See Also:
  `cern.colt.map`, `OpenIntDoubleHashMap`, Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Constructor Summary
`SparseDoubleMatrix2D(double[][] values)` Constructs a matrix with a copy of the given values.
`SparseDoubleMatrix2D(int rows, int columns)` Constructs a matrix with a given number of rows and columns and default memory usage.
`SparseDoubleMatrix2D(int rows, int columns, int initialCapacity, double minLoadFactor, double maxLoadFactor)` Constructs a matrix with a given number of rows and columns using memory as specified.

Method Summary
`DoubleMatrix2D` | `assign(double value)` Sets all cells to the state specified by `value`.
`DoubleMatrix2D` | `assign(DoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.
`DoubleMatrix2D` | `assign(DoubleMatrix2D source)` Replaces all cell values of the receiver with the values of another matrix.
`DoubleMatrix2D` | `assign(DoubleMatrix2D y, DoubleDoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
`int` | `cardinality()` Returns the number of cells having non-zero values.
`void` | `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory.
`DoubleMatrix2D` | `forEachNonZero(IntIntDoubleFunction function)` Assigns the result of a function to each non-zero cell; `x[row,col] = function(x[row,col])`.
`double` | `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
`DoubleMatrix2D` | `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
`DoubleMatrix1D` | `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
`void` | `setQuick(int row, int column, double value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
`void` | `trimToSize()` Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.
`DoubleMatrix1D` | `zMult(DoubleMatrix1D y, DoubleMatrix1D z, double alpha, double beta, boolean transposeA)` Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`.
`DoubleMatrix2D` | `zMult(DoubleMatrix2D B, DoubleMatrix2D C, double alpha, double beta, boolean transposeA, boolean transposeB)` Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`.

Methods inherited from class cern.colt.matrix.DoubleMatrix2D
`aggregate, aggregate, assign, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSorted, viewStrides, zAssign8Neighbors, zMult, zMult, zSum`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D
`checkShape, checkShape, columns, rows, size, toStringShort`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SparseDoubleMatrix2D

    public SparseDoubleMatrix2D(double[][] values)

  Constructs a matrix with a copy of the given values. `values` is required to have the form `values[row][column]` and have exactly the same number of columns in every row.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

Parameters:
  `values` - The values to be filled into the new matrix.
Throws:
  `IllegalArgumentException` - if `for any 1 <= row < values.length: values[row].length != values[row-1].length`.

### SparseDoubleMatrix2D

    public SparseDoubleMatrix2D(int rows,
                                int columns)

  Constructs a matrix with a given number of rows and columns and default memory usage. All entries are initially `0`.

Parameters:
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
Throws:
  `IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

### SparseDoubleMatrix2D

    public SparseDoubleMatrix2D(int rows,
                                int columns,
                                int initialCapacity,
                                double minLoadFactor,
                                double maxLoadFactor)

  Constructs a matrix with a given number of rows and columns using memory as specified. All entries are initially `0`. For details related to memory usage see `OpenIntDoubleHashMap`.

Parameters:
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
  `initialCapacity` - the initial capacity of the hash map. If not known, set `initialCapacity=0` or small.
  `minLoadFactor` - the minimum load factor of the hash map.
  `maxLoadFactor` - the maximum load factor of the hash map.
Throws:
  `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.
  `IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

Method Detail

### assign

    public DoubleMatrix2D assign(double value)

  Sets all cells to the state specified by `value`.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `value` - the value to be filled into the cells.
  Returns:
    `this` (for convenience only).

### assign

    public DoubleMatrix2D assign(DoubleFunction function)

  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.

  Example:

      matrix = 2 x 2 matrix
      0.5 1.5
      2.5 3.5

      // change each cell to its sine
      matrix.assign(cern.jet.math.Functions.sin);
      -->
      2 x 2 matrix
      0.479426  0.997495
      0.598472 -0.350783

  For further examples, see the package doc.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `function` - a function object taking as argument the current cell's value.
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### assign

    public DoubleMatrix2D assign(DoubleMatrix2D source)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `source` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `columns() != source.columns() || rows() != source.rows()`

### assign

    public DoubleMatrix2D assign(DoubleMatrix2D y,
                                 DoubleDoubleFunction function)

  Description copied from class: `DoubleMatrix2D`
  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

  Example:

      // assign x[row,col] = x[row,col]y[row,col]
      m1 = 2 x 2 matrix
      0 1
      2 3

      m2 = 2 x 2 matrix
      0 2
      4 6

      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 2 x 2 matrix
       1   1
      16 729

  For further examples, see the package doc.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values.

  Overrides:
    `cardinality` in class `DoubleMatrix2D`

### ensureCapacity

    public void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of non-zero cells without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  This method never need be called; it is for performance tuning only. Calling this method before tt>set()ing a large number of non-zero values boosts performance, because the receiver will grow only once instead of potentially many times and hash collisions get less probable.

  Overrides:
    `ensureCapacity` in class `AbstractMatrix`
  Parameters:
    `minCapacity` - the desired minimum number of non-zero (non-null) cells.

### forEachNonZero

    public DoubleMatrix2D forEachNonZero(IntIntDoubleFunction function)

  Description copied from class: `DoubleMatrix2D`
  Assigns the result of a function to each non-zero cell; `x[row,col] = function(x[row,col])`. Use this method for fast special-purpose iteration. If you want to modify another matrix instead of `this` (i.e. work in read-only mode), simply return the input value unchanged. Parameters to function are as follows: `first==row`, `second==column`, `third==nonZeroValue`.

  Overrides:
    `forEachNonZero` in class `DoubleMatrix2D`
  Parameters:
    `function` - a function object taking as argument the current non-zero cell's row, column and value.
  Returns:
    `this` (for convenience only).

### getQuick

    public double getQuick(int row,
                           int column)

  Returns the matrix cell value at coordinate `[row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Specified by:
    `getQuick` in class `DoubleMatrix2D`
  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public DoubleMatrix2D like(int rows,
                               int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must also be of type `DenseDoubleMatrix2D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must also be of type `SparseDoubleMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Specified by:
    `like` in class `DoubleMatrix2D`
  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### like1D

    public DoubleMatrix1D like1D(int size)

  Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must be of type `DenseDoubleMatrix1D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must be of type `SparseDoubleMatrix1D`, etc.

  Specified by:
    `like1D` in class `DoubleMatrix2D`
  Parameters:
    `size` - the number of cells the matrix shall have.
  Returns:
    a new matrix of the corresponding dynamic type.

### setQuick

    public void setQuick(int row,
                         int column,
                         double value)

  Sets the matrix cell at coordinate `[row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Specified by:
    `setQuick` in class `DoubleMatrix2D`
  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### trimToSize

    public void trimToSize()

  Releases any superfluous memory created by explicitly putting zero values into cells formerly having non-zero values; An application can use this operation to minimize the storage of the receiver.

  Background:

  Cells that

  - are never set to non-zero values do not use any memory.
  - switch from zero to non-zero state do use memory.
  - switch back from non-zero to zero state also do use memory. However, their memory can be reclaimed by calling `trimToSize()`.
  A sequence like `set(r,c,5); set(r,c,0);` sets a cell to non-zero state and later back to zero state. Such as sequence generates obsolete memory that is automatically reclaimed from time to time or can manually be reclaimed by calling `trimToSize()`. Putting zeros into cells already containing zeros does not generate obsolete memory since no memory was allocated to them in the first place.

  Overrides:
    `trimToSize` in class `AbstractMatrix`

### zMult

    public DoubleMatrix1D zMult(DoubleMatrix1D y,
                                DoubleMatrix1D z,
                                double alpha,
                                double beta,
                                boolean transposeA)

  Description copied from class: `DoubleMatrix2D`
  Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`. `z[i] = alpha*Sum(A[i,j] * y[j]) + beta*z[i], i=0..A.rows()-1, j=0..y.size()-1`. Where `A == this`.
  Note: Matrix shape conformance is checked after potential transpositions.

  Overrides:
    `zMult` in class `DoubleMatrix2D`
  Parameters:
    `y` - the source vector.
    `z` - the vector where results are to be stored. Set this parameter to `null` to indicate that a new result vector shall be constructed.
  Returns:
    z (for convenience only).

### zMult

    public DoubleMatrix2D zMult(DoubleMatrix2D B,
                                DoubleMatrix2D C,
                                double alpha,
                                double beta,
                                boolean transposeA,
                                boolean transposeB)

  Description copied from class: `DoubleMatrix2D`
  Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`. `C[i,j] = alpha*Sum(A[i,k] * B[k,j]) + beta*C[i,j], k=0..n-1`.
  Matrix shapes: `A(m x n), B(n x p), C(m x p)`.
  Note: Matrix shape conformance is checked after potential transpositions.

  Overrides:
    `zMult` in class `DoubleMatrix2D`
  Parameters:
    `B` - the second source matrix.
    `C` - the matrix where results are to be stored. Set this parameter to `null` to indicate that a new result matrix shall be constructed.
  Returns:
    C (for convenience only).

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage